
                        NOLIST

;---------------------------------------------------------------------------
;definicje

#define _IRP            STATUS, IRP
#define _RP0            STATUS, RP0
#define _RP1            STATUS, RP1
#define _Z              STATUS, Z
#define _C              STATUS, C
#define _CARRY          STATUS, C

#define OPTION          OPTION_REG
#define _RBPU           OPTION_REG, NOT_RBPU
#define _INTEDG         OPTION_REG, INTEDG
#define _T0CS           OPTION_REG, T0CS
#define _T0SE           OPTION_REG, T0SE
#define _PSA            OPTION_REG, PSA
#define _PRE            OPTION_REG, PRE

#define _GIE            INTCON, GIE
#define _PEIE           INTCON, PEIE
#define _T0IE           INTCON, T0IE
#define _INTE           INTCON, INTE
#define _RBIE           INTCON, RBIE
#define _T0IF           INTCON, T0IF
#define _INTF           INTCON, INTF
#define _RBIF           INTCON, RBIF

;+++++++++++++++++++++++++++++++  USART  +++++++++++++++++++++++++++++++++++

#define _TXIE           PIE1, TXIE       ;1 wlacza USART transmiter  - bank1
#define _RCIE           PIE1, RCIE       ;1 wlacza USART receiver    - bank1

#define _TXIF           PIR1, TXIF       ;bit przerwania             - bank0
#define _RCIF           PIR1, RCIF       ;bit przerwania             - bank0

#define _BRGH           TXSTA, BRGH      ;1 high speed USART         - bank1
#define _TXEN           TXSTA, TXEN      ;1 zezwolenie na transmisje - bank1
#define _TRMT           TXSTA, TRMT      ;status transmisji          - bank1

#define _SPEN           RCSTA, SPEN      ;1 wlaczenie seriala        - bank0
#define _CREN           RCSTA, CREN      ;1 wlacza ciaglosc odbioru  - bank0

;+++++++++++++++++++++++++++++++  adcon  +++++++++++++++++++++++++++++++++++

#define _ADCS1          ADCON0, ADCS1    ;clock select               - bank0
#define _ADCS0          ADCON0, ADCS0    ;clock select               - bank0
#define _GO             ADCON0, GO       ;conversion status          - bank0
#define _DONE           ADCON0, GO       ;conversion status          - bank0
#define _ADON           ADCON0, ADON     ;on bit                     - bank0

#define _ADFM           ADCON1, ADFM     ;format select              - bank1

#define _ADIE           PIE1, ADIE       ;interrupt enable           - bank1

#define _ADIF           PIR1, ADIF       ;interrupt flag             - bank0

;+++++++++++++++++++++++++++++++   i2c   +++++++++++++++++++++++++++++++++++

#define _SMP            SSPSTAT, SMP     ;0 slew rate control enabled - bank1
#define _CKE            SSPSTAT, CKE     ;i2c levels                  - bank1
#define _DA             SSPSTAT, DA      ;last byte data/adres        - bank1
#define _P              SSPSTAT, P       ;1 stop bit detected         - bank1
#define _S              SSPSTAT, S       ;1 start bit detected        - bank1
#define _BF             SSPSTAT, BF      ;1 SSPBUF is full            - bank1

#define _WCOL           SSPCON, WCOL     ;                            - bank0
#define _SSPOV          SSPCON, SSPOV    ;1 new byte receiveed        - bank0
#define _SSPEN          SSPCON, SSPEN    ;1 enables SDA i SCL         - bank0
#define _CKP            SSPCON, CKP      ;1 enables Clock             - bank0

#define _ACKSTAT        SSPCON2, ACKSTAT ;0 ack was received          - bank1
#define _ACKDT          SSPCON2, ACKDT   ;0 ack                       - bank1
#define _ACKEN          SSPCON2, ACKEN   ;1 init ack                  - bank1
#define _RCEN           SSPCON2, RCEN    ;1 receive enable            - bank1
#define _PEN            SSPCON2, PEN     ;1 init stop                 - bank1
#define _RSEN           SSPCON2, RSEN    ;1 repeat start              - bank1
#define _SEN            SSPCON2, SEN     ;1 init start                - bank1

#define _SSPIE          PIE1, SSPIE      ;1 SSP enable                - bank1

#define _SSPIF          PIR1, SSPIF      ;1 interrupt occurred        - bank0

;---------------------------------------------------------------------------
;makra

clc           MACRO                      ;clear carry bit
                bcf     STATUS, C
              ENDM

stc           MACRO                      ;set carry bit
                bsf     STATUS, C
              ENDM

bank0         MACRO
                bcf     STATUS, RP0
              ENDM

bank1         MACRO
                bsf     STATUS, RP0
              ENDM

bank_0        MACRO
                bcf     STATUS, RP0
                bcf     STATUS, RP1
              ENDM

bank_1        MACRO
                bsf     STATUS, RP0
                bcf     STATUS, RP1
              ENDM

bank_2        MACRO
                bcf     STATUS, RP0
                bsf     STATUS, RP1
              ENDM

bank_3        MACRO
                bsf     STATUS, RP0
                bsf     STATUS, RP1
              ENDM

jb            MACRO fr, bit, addr        ;jump if bit is set
                btfsc   fr, bit
                goto    addr
              ENDM

jnb           MACRO fr, bit, addr        ;jump if bit is not set
                btfss   fr, bit
                goto    addr
              ENDM

retb          MACRO fr, bit              ;return if bit is set
                btfsc   fr, bit
                return
              ENDM

retnb         MACRO fr, bit              ;return if bit is not set
                btfss   fr, bit
                return
              ENDM

jbp           MACRO Port, bit, addr      ;jump if port bit is set
                bcf     STATUS, RP0
                btfsc   fr, bit
                goto    addr
              ENDM

jnbp          MACRO Port, bit, addr      ;jump if port bit is not set
                bcf     STATUS, RP0
                btfss   fr, bit
                goto    addr
              ENDM

jc            MACRO addr                 ;jump if carry bit is set
                btfsc   STATUS, C
                goto    addr
              ENDM

jnc           MACRO addr                 ;jump if carry bit is not set
                btfss   STATUS, C
                goto    addr
              ENDM

jz            MACRO addr                 ;jump if zero bit is set
                btfsc   STATUS, Z
                goto    addr
              ENDM

callz         MACRO addr                 ;call if zero bit is set
                btfsc   STATUS, Z
                call    addr
              ENDM

callb         MACRO fr, bit, addr        ;call if bit is set
                btfsc   fr, bit
                call    addr
              ENDM

callnb        MACRO fr, bit, addr        ;call if bit is not set
                btfss   fr, bit
                call    addr
              ENDM

jnz           MACRO addr                 ;jump if zero bit is not set
                btfss   STATUS, Z
                goto    addr
              ENDM

movl          MACRO fr, L                ;move L into fr
                movlw   L
                movwf   fr
              ENDM

mov           MACRO fr1, fr2             ;move fr2 into fr1
                movf    fr2, W
                movwf   fr1
              ENDM

mov01         MACRO fr1, fr2             ;move fr2 into fr1
                bsf     _RP0
                movf    fr2, W
                bcf     _RP0
                movwf   fr1
              ENDM

mov10         MACRO fr1, fr2             ;move fr2 into fr1
                bcf     _RP0
                movf    fr2, W
                bsf     _RP0
                movwf   fr1
              ENDM

mov0100       MACRO fr1, fr2             ;move fr2 into fr1
                movf    fr2, W
                bsf     _RP0
                movwf   fr1
                bcf     _RP0
              ENDM

mov1100       MACRO fr1, fr2             ;move fr2 into fr1
                movf    fr2, W
                bsf     _RP0
                movwf   fr1
              ENDM

mov0011       MACRO fr1, fr2             ;move fr2 into fr1
                movf    fr2, W
                bcf     _RP0
                movwf   fr1
              ENDM


mov0010       MACRO fr1, fr2             ;move fr2 into fr1
                bsf     _RP0
                movf    fr2, W
                bcf     _RP0
                movwf   fr1
              ENDM

mov02         MACRO fr1, fr2             ;move fr2 into fr1
                bsf     _RP1
                movf    fr2, W
                bcf     _RP1
                movwf   fr1
              ENDM

push_stat_w   MACRO                      ;F8X
                movwf   W_STACK          ;zapamietaj W
                swapf   STATUS, W        ;i STATUS na "stosie"
                movwf   STATUS_STACK
                movf    FSR, W
                movwf   FSR_STACK
              ENDM

pop_stat_w    MACRO                      ;F8X
                movf    FSR_STACK, W
                movwf   FSR
                swapf   STATUS_STACK, W  ;pobierz W i STATUS ze stosu
                movwf   STATUS
                swapf   W_STACK, F
                swapf   W_STACK, W
              ENDM

save          MACRO                      ;F87X
                movwf   W_STACK
                swapf   STATUS, W
                clrf    STATUS
                movwf   STATUS_STACK
                movf    FSR, W
                movwf   FSR_STACK
              ENDM

restore       MACRO                      ;F87X
                clrf    STATUS
                movf    FSR_STACK, W
                movwf   FSR
                swapf   STATUS_STACK, W
                movwf   STATUS
                swapf   W_STACK, F
                swapf   W_STACK, W
              ENDM

save_com      MACRO
                movwf   W_STACK
                swapf   STATUS, W
                movwf   STATUS_STACK
                movf    FSR, W
                movwf   FSR_STACK
              ENDM

restore_com   MACRO
                movf    FSR_STACK, W
                movwf   FSR
                swapf   STATUS_STACK, W
                movwf   STATUS
                swapf   W_STACK, F
                swapf   W_STACK, W
              ENDM

djnz          MACRO fr, addr             ;decrement fr and jump when not zero
                decfsz  fr, F
                goto    addr
              ENDM

decz          MACRO fr                   ;decrement fr and test overflow
                decf    fr, F
                comf    fr, W
              ENDM

ijnz          MACRO fr, addr             ;decrement fr and jump when not zero
                incfsz  fr, F
                goto    addr
              ENDM

addl          MACRO fr, L                ;add L into fr
                movlw   L
                addwf   fr, F
              ENDM

add           MACRO fr1, fr2             ;add fr2 into fr1
                movf    fr2, W
                addwf   fr1, F
              ENDM

addb          MACRO fr, Port, bit        ;add bit to fr
                btfsc   Port, bit
                incf    fr, F
              ENDM

andl          MACRO fr, L                ;bitwise and L mask to fr
                movlw   L
                andwf   fr, F
              ENDM

and           MACRO fr1, fr2             ;bitwise and fr1 with fr2 mask
                movf    fr2, W
                andwf   fr1, F
              ENDM

cjal          MACRO fr, L, addr          ;compare and jump if fr > L
                movlw   L^0xFF
                addwf   fr, W
                btfsc   STATUS, C
                goto    addr
              ENDM

cja           MACRO fr1, fr2, addr       ;compare and jump if fr1 > fr2
                movf    fr1, W
                subwf   fr2, W
                btfss   STATUS, C
                goto    addr
              ENDM

cjael         MACRO fr, L, addr          ;compare and jump if fr >= L
                movlw   L
                subwf   fr, W
                btfsc   STATUS, C
                goto addr
              ENDM

cjae          MACRO fr1, fr2, addr       ;compare and jump if fr1 >= fr2
                movf    fr2, W
                subwf   fr1, W
                btfsc   STATUS, C
                goto    addr
              ENDM

cjbl          MACRO fr, L, addr          ;compare and jump if fr < L
                movlw   L
                subwf   fr, W
                btfss   STATUS, C
                goto    addr
              ENDM

cjb           MACRO fr1, fr2, addr       ;compare and jump if fr1 < fr2
                movf    fr2, W
                subwf   fr1, W
                btfss   STATUS, C
                goto    addr
              ENDM

cjbel         MACRO fr, L, addr          ;compare and jump if fr <= L
                movlw   L^0xFF
                addwf   fr, W
                btfss   STATUS, C
                goto    addr
              ENDM

cjbe          MACRO fr1, fr2, addr       ;compare and jump if fr1 <= fr2
                movf    fr1, W
                subwf   fr2, W
                btfsc   STATUS, C
                goto    addr
              ENDM

cjel          MACRO fr, L, addr          ;compare and jump if fr = L
                movlw   L
                subwf   fr, W
                btfsc   STATUS, Z
                goto    addr
              ENDM

cje           MACRO fr1, fr2, addr       ;compare and jump if fr1 = fr2
                movf    fr2, W
                subwf   fr1, W
                btfsc   STATUS, Z
                goto    addr
              ENDM

cjnel         MACRO fr, L, addr          ;compare and jump if fr != L
                movlw   L
                subwf   fr, W
                btfss   STATUS, Z
                goto    addr
              ENDM

cjne          MACRO fr1, fr2, addr       ;compare and jump if fr1 != fr2
                movf    fr2, W
                subwf   fr1, W
                btfss   STATUS, Z
                goto    addr
              ENDM

;Below only work on single instructions
csal          MACRO fr, L                ;compare and skip if fr > L
                movlw   L^0xFF
                addwf   fr, W
                btfss   STATUS, C
              ENDM

csa           MACRO fr1, fr2             ;compare and skip if fr1 > fr2
                movf    fr1, W
                subwf   fr2, W
                btfsc   STATUS, C
              ENDM

csael         MACRO fr, L                ;compare and skip if fr >= L
                movlw   L
                subwf   fr, W
                btfss   STATUS, C
              ENDM

csae          MACRO fr1, fr2             ;compare and skip if fr1 >= fr2
                movf    fr2, W
                subwf   fr1, W
                btfss   STATUS, C
              ENDM

csbl          MACRO fr, L                ;compare and skip if fr < L
                movlw   L
                subwf   fr, W
                btfsc   STATUS, C
              ENDM

csb           MACRO fr1, fr2             ;compare and skip if fr1 < fr2
                movf    fr2, W
                subwf   fr1, W
                btfsc   STATUS, C
              ENDM

csbel         MACRO fr, L                ;compare and skip if fr <= L
                movlw   L^0xFF
                addwf   fr, W
                btfsc   STATUS, C
              ENDM

csbe          MACRO fr1, fr2             ;compare and skip if fr1 <= fr2
                movf    fr1, W
                subwf   fr2, W
                btfss   STATUS, C
              ENDM

csel          MACRO fr, L                ;compare and skip if fr = L
                movlw   L
                subwf   fr, W
                btfss   STATUS, Z
              ENDM

cse           MACRO fr1, fr2             ;compare and skip if fr1 = fr2
                movf    fr2, W
                subwf   fr1, W
                btfss   STATUS, Z
              ENDM

csnel         MACRO fr, L                ;compare and skip if fr != L
                movlw   L
                subwf   fr, W
                btfsc   STATUS, Z
              ENDM

csne          MACRO fr1, fr2             ;compare and skip if fr1 != fr2
                movf    fr2, W
                subwf   fr1, W
                btfsc   STATUS, Z
              ENDM

movb          MACRO Port1, bit1, Port2, bit2 ;move Port2, bit2 into Port1, bit1
                btfss   Port2, bit2
                bcf     Port1, bit1
                btfsc   Port2, bit2
                bsf     Port1, bit1
              ENDM

movnb         MACRO Port1, bit1, Port2, bit2 ;move NOT Port2, bit2 into Port1, bit1
                btfsc   Port2, bit2
                bcf     Port1, bit1
                btfss   Port2, bit2
                bsf     Port1, bit1
              ENDM

neg           MACRO fr                   ;twos complement negation of fr
                comf    fr, F
                incf    fr, F
              ENDM

not           MACRO fr                   ;ones complement NOT fr
                comf    fr, F
              ENDM

or            MACRO fr1, fr2             ;bitwise OR fr2 mask into fr1
                movf    fr2, W
                iorwf   fr1, F
              ENDM

orl           MACRO fr, L                ;bitwise OR L mask into fr1
                movlw   L
                iorwf   fr, F
              ENDM

shl           MACRO fr                   ;rotate left
                rlf     fr, W
                rlf     fr, F
              ENDM

shr           MACRO fr                   ;rotate right
                rrf     fr, W
                rrf     fr, F
              ENDM

sb            MACRO Port, bit            ;skip if bit is set
                btfss   Port, bit
              ENDM

snb           MACRO Port, bit            ;skip if bit is cleared
                btfsc   Port, bit
              ENDM

sc            MACRO                      ;skip if carry bit is set
                btfss   STATUS, C
              ENDM

snc           MACRO                      ;skip if carry bit is cleared
                btfsc   STATUS, C
              ENDM

sz            MACRO                      ;skip if zero bit is set
                btfss   STATUS, Z
              ENDM

snz           MACRO                      ;skip if zero bit is cleared
                btfsc   STATUS, Z
              ENDM

subl          MACRO fr, L                ;subtract L from fr
                movlw   L
                subwf   fr, F
              ENDM

sub           MACRO fr1, fr2             ;subtract fr2 from fr1
                movf    fr2, W
                subwf   fr1, F
              ENDM

subb          MACRO fr, Port, bit        ;subtract bit from fr
                btfss   Port, bit
                decf    fr, F
              ENDM

swapwf        MACRO fr                   ;swap W and fr values
                xorwf   fr, F
                xorwf   fr, W
                xorwf   fr, F
              ENDM

test          MACRO fr                   ;set or clear zero bit
                movf    fr, F
              ENDM

tb            MACRO fr, bit              ;toggle bit in fr
                movlw   1<<bit
                xorwf   fr, F
              ENDM

xorl          MACRO fr, L                ;exclusive or fr with L mask
                movlw   L
                xorwf   fr, F
              ENDM

xor           MACRO fr1, fr2             ;exclusive or fr1 with fr2 mask
                movf    fr2, W
                xorwf   fr1, F
              ENDM

wait          MACRO fr                   ;Delay of 3*(fr-1)+2 cycles (Osc/4)
                decfsz  fr, F
                goto    $ - 1
              ENDM

delay         MACRO fr, L                ;Delay L Tcycles (775 > L > 6)
                movlw   (L - 3) / 3
                movwf   fr
                Wait    fr
                movlw   9 + 3 * ((L - 7) / 3) - L
                addwf   PCL, F
                nop
                nop
              ENDM

lncall        MACRO dest                 ;Long call to destination
                movlw   HIGH dest
                movwf   pclath           ;set page bits before call
                call    dest
                movlw   HIGH $
                movwf   pclath           ;resets page bits to current
              ENDM                       ;location after return

;tabcall       MACRO dest, pos, tab       ;odczyt z tablicy
;                movl    PCLATH, HIGH dest
;                movf    pos, W
;                call    dest
;                movwf   tab
;                movl    PCLATH, HIGH $
;              ENDM

tabcall       MACRO dest, pos, tab       ;odczyt z tablicy
                mov     PCHTEMP, PCLATH
                movl    pclath, HIGH dest
                movf    pos, W
                call    dest
                movwf   tab
                mov     PCLATH, PCHTEMP
              ENDM

lnjump        MACRO dest                 ;Long goto to destination
                movlw   HIGH dest
                movwf   pclath           ;set page bits before jump
                goto    dest
              ENDM

;---------------------------------------------------------------------------

              LIST