;--------------------------------------------------------------------------
;PicBoard1 Demo v1.0
;Copyright by Adam Jurkiewicz, 25.10.2003
;Source: http://ajpic.zonk.pl/
;E-mail: sword@ajpic.zonk.pl
;--------------------------------------------------------------------------

                Processor       16F628
                Radix           dec

                include         <p16f628.inc>
                include         <makra.asm>

                __config _BODEN_ON & _CP_OFF & _PWRTE_ON & _WDT_OFF & _LVP_OFF & _MCLRE_ON & _HS_OSC

;--------------------------------------------------------------------------
;definicja stalych
;--------------------------------------------------------------------------

#define XTAL            4000000          ;wartosc przylaczonego kwarcu [Hz]
;#define XTAL            11059200         ;wartosc przylaczonego kwarcu [Hz]

#define DEL             169              ;opoznienie

;--------------------------------------------------------------------------

#define P0              PORTB, 4
#define P1              PORTB, 5
#define P2              PORTB, 6
#define P3              PORTB, 7

;--------------------------------------------------------------------------
;deklaracja zmiennych
;--------------------------------------------------------------------------

RAM0            equ     0x20             ;poczatek pamieci RAM w banku 0
RAM1            equ     0xA0             ;poczatek pamieci RAM w banku 1
RAMCOM          equ     0x70             ;poczatek wspolnej pamieci RAM

              cblock  RAM0               ;blok zmiennych
                DELAY_L
                DELAY_H
                OUT
                COUNT
                DELAYN
                CURRRENT_LINE
              endc

;--------------------------------------------------------------------------

                org     0x0000           ;wektor resetu
                goto    start

;--------------------------------------------------------------------------

                org     0x0004           ;wektor przerwania
                retfie

;--------------------------------------------------------------------------
line0:                                   ;tablica 0 z danymi
                andlw   0x0f
                addwf   PCL, F
                retlw   00000001b
                retlw   00000010b
                retlw   00000100b
                retlw   00001000b
                retlw   00010000b
                retlw   00100000b
                retlw   01000000b
                retlw   10000000b
                retlw   10000000b
                retlw   01000000b
                retlw   00100000b
                retlw   00010000b
                retlw   00001000b
                retlw   00000100b
                retlw   00000010b
                retlw   00000001b

;--------------------------------------------------------------------------
line1:                                   ;tablica 1 z danymi
                andlw   0x0f
                addwf   PCL, F
                retlw   00011000b
                retlw   00100100b
                retlw   01000010b
                retlw   10000001b
                retlw   10000001b
                retlw   01000010b
                retlw   00100100b
                retlw   00011000b
                retlw   00011000b
                retlw   00100100b
                retlw   01000010b
                retlw   10000001b
                retlw   10000001b
                retlw   01000010b
                retlw   00100100b
                retlw   00011000b

;--------------------------------------------------------------------------
line2:                                   ;tablica 2 z danymi
                andlw   0x0f
                addwf   PCL, F
                retlw   10001000b
                retlw   01000100b
                retlw   00100010b
                retlw   00010001b
                retlw   00010001b
                retlw   00100010b
                retlw   01000100b
                retlw   10001000b
                retlw   10001000b
                retlw   01000100b
                retlw   00100010b
                retlw   00010001b
                retlw   00010001b
                retlw   00100010b
                retlw   01000100b
                retlw   10001000b

;--------------------------------------------------------------------------
line3:                                   ;tablica 3 z danymi
                andlw   0x0f
                addwf   PCL, F
                retlw   10000000b
                retlw   11000000b
                retlw   11100000b
                retlw   11110000b
                retlw   11111000b
                retlw   11111100b
                retlw   11111110b
                retlw   11111111b
                retlw   11111111b
                retlw   11111110b
                retlw   11111100b
                retlw   11111000b
                retlw   11110000b
                retlw   11100000b
                retlw   11000000b
                retlw   10000000b

;--------------------------------------------------------------------------
delay1:
                movl    DELAY_H, high (XTAL / DEL)
                movl    DELAY_L, low  (XTAL / DEL)
                djnz    DELAY_L, $ - 1
                djnz    DELAY_H, $ - 5

                return

;--------------------------------------------------------------------------
;--------------------------------------------------------------------------
;--------------------------------------------------------------------------
start:
                movl    CMCON, 0x07      ;wylacz komparator
                bank1
                movl    TRISA, 0xf0      ;ustaw polowki portow jako wyjscia
                movl    TRISB, 0xf0
                bcf     _RBPU            ;zalacz pullup'y na RB
                bank0

                movl    CURRRENT_LINE, 0x01 ;ustaw domyslna tablice
                clrf    COUNT               ;ustaw licznik pozycji
main_1:
                movf    COUNT, W            ;ustaw wskaznik
                callb   CURRRENT_LINE, 0, line0  ;pobierz dana z tablicy
                callb   CURRRENT_LINE, 1, line1
                callb   CURRRENT_LINE, 2, line2
                callb   CURRRENT_LINE, 3, line3
                movwf   OUT

                movwf   PORTA            ;wpisz pol danej do portu RA

                swapf   OUT, W           ;zamien polowki
                movwf   PORTB            ;wpisz pol danej do portu RB

                movl    DELAYN, 2        ;opoznienie stale

                cjel    COUNT, 0x00, m_1 ;sprawdz polozenie wskaznika
                cjnel   COUNT, 0x07, m_2
m_1:
                movl    DELAYN, 4        ;opoznienie krancowe
m_2:
                call    delay1           ;wywolaj opozninie
                djnz    DELAYN, $ - 2

                incf    COUNT            ;zwieksz wskaznik
                andl    COUNT, 0x0f      ;sprawdz czy koniec

                jb      P0, m_3          ;test klawisza P0
                clrf    CURRRENT_LINE
                bsf     CURRRENT_LINE, 0 ;ustaw wskaznik na tablice line0
m_3:
                jb      P1, m_4          ;test klawisza P1
                clrf    CURRRENT_LINE
                bsf     CURRRENT_LINE, 1 ;ustaw wskaznik na tablice line1
m_4:
                jb      P2, m_5          ;test klawisza P2
                clrf    CURRRENT_LINE
                bsf     CURRRENT_LINE, 2 ;ustaw wskaznik na tablice line2
m_5:
                jb      P3, m_6          ;test klawisza P3
                clrf    CURRRENT_LINE
                bsf     CURRRENT_LINE, 3 ;ustaw wskaznik na tablice line3
m_6:
                goto    main_1           ;petla glowna

;--------------------------------------------------------------------------

                end
